# App Framework

A combination of great pieces of open source code to let you develop, build and deploy a new application in minutes. With App Framework, you can spend your time for what makes your application unique, not the tricky stuff around!

> Version 4 is still under development. [Version 1](https://github.com/scriptPilot/app-framework/tree/v1#app-framework------) is the latest stable one, focussed on Framework7Vue.

&nbsp;

![Process](./docs/images/process.png)

&nbsp;

## Features

- [ ] **Powerful JavaScript Framework** - based on [Vue.js](https://vuejs.org/), [React](https://reactjs.org/) or [Angular](https://angular.io/).
- [ ] **Beautiful UX Framework** - choose [Material Design](https://material.io/design/), [Bootstrap](https://getbootstrap.com/), [Framework7](https://framework7.io/) or [SAP UI5](https://sap.github.io/ui5-webcomponents/).
- [ ] **Comprehensive Icon Fonts** - like [FontAwesome](http://fontawesome.io/), [Framework7 Icons](http://framework7.io/icons/), [Ion Icons](http://ionicons.com/) and [Material Design Icons](https://material.io/icons/).
- [ ] **Hardware APIs** - provided by [Capacitor](https://capacitor.ionicframework.com/) and [Cordova](https://cordova.apache.org/).
- [ ] **One Code Base** - with HTML, CSS and JavaScript with ES6 support.
- [ ] **Local Development Server** - with live reload, perfectly to use together with [Chrome DevTools](https://developers.google.com/web/tools/chrome-devtools/).
- [ ] **Native Build** - as [PWA](https://developers.google.com/web/progressive-web-apps/), mobile App (iOS or Android) or desktop App (macOS, Windows or Linux).
- [ ] **Icon Generation** - for favicon, touch icons and splash screens, out of a single image file with [Jimp](https://github.com/oliver-moran/jimp).
- [ ] **Easy Deployment** - without downtime, to the Apple App Store, Google Play Store, [Firebase](https://firebase.google.com/products/hosting/) or any FTP server.

&nbsp;

## Quick Start

1. Run `npx app-framework` to open a wizard which will guide you to your new application project.
2. Run `npx app dev` to open a development server in the web browser.
3. Run `npx app build` to build your application as [Progressive Web App](https://developers.google.com/web/progressive-web-apps/).
